// 创建项目

const child_process = require('child_process');
const fs = require('fs')
const { resolve, join } = require('path')
const { useOra } = require('./hooks')

module.exports = (name) => {
  if (dirExist(name)) {
    console.log('存在, 请更换工程名');
    return
  }
  // 创建工程目录
  createDir(name)
  // 写入模板
  const orgUrl = resolve(__dirname, '../template'),
        destUrl = resolve(process.cwd(), name)
  copy(orgUrl, destUrl)
  /* 
    1. 进入工程，初始化git
    2. 安装依赖
  */
  initProject(name)
}

function dirExist(dirName) {
  return fs.existsSync(dirName)
}

function createDir(dirName) {
  const dirRoot = resolve(process.cwd(), dirName) 
  fs.mkdirSync(dirRoot)
}

function copy(orgUrl, destUrl) {
  fs.cpSync(orgUrl, destUrl, { 'recursive': true })
}

function initProject(name) {
  child_process.execSync('git init', {
    'cwd': resolve(process.cwd(), name)
  })
  const { load, succeed } = useOra()
  load('开始安装...')
  child_process.execSync('yarn', {
    'cwd': resolve(process.cwd(), name)
  })
  succeed('安装完成!')
}