const ora = require('ora')

const useOra = (text = 'Loading...') => {
  const oraInstance = ora({
    text,
  })

  const load = (txt = '开始...') => oraInstance.start(txt)
  const end = () => oraInstance.end()
  const succeed = (txt = '成功') => oraInstance.succeed(txt)
  const fail = (txt = '失败') => oraInstance.fail(txt)

  return {
    load,
    end,
    succeed,
    fail,
  }
}

module.exports = {
  useOra,
}