#!/usr/bin/env node

const { program } = require('commander')
const inquirer = require('inquirer')
const { get } = require('axios')
const fs = require('fs')
const http = require('http')
const path = require('path')

program
  .command('create')
  .action(async () => {
    const res = await inquirer.prompt([
      {
        type: 'input',
        name: 'appName',
        message: '请输入项目名称',
        default: 'app-project'
      }
    ])
    require('./create')(res.appName)
  })

program
  .command('addLint')
  .action(() => {
    require('./addLint')()
  })

program
  .command('load')
  .option('--song <char>')
  .action(async (options) => {
    const {data: { result: { songs } } } = await get('http://zhoup.top:7003/search?keywords=' + encodeURIComponent(options.song))
    const choose = songs.map(item => {
      return { name: item.name, value: item.id, short: item.name }
    })
    inquirer.prompt([
      {
        type: 'list',
        choices: choose,
        name: 'id'
      }
    ]).then(res => {
      console.log(res)
    })
  })

program
  .command('down')
  .action(() => {
    const url = 'http://m8.music.126.net/20220818232606/10ce05a423c6cf1789f513fb575d4c94/ymusic/obj/w5zDlMODwrDDiGjCn8Ky/3036222985/f34b/cf39/4009/f9f78b87e872c3105830ca640a32cb25.mp3'
    const file = fs.createWriteStream(path.resolve(process.cwd(), './咖啡.mp3'))
    http.get(url, res => {
      res.pipe(file)
      res.on('end', () => {
        console.log('下载完成')
      })
      file.on('finish', () => {
        console.log('写入完成');
      })
    })
  })

program.parse(process.argv)